#include 	<sys/bios.h>
#include	<stdio.h>
#include 	<fcntl.h>
#include	<stdlib.h>
#include	<string.h>
#include	"pattern.h"

#define		BUF_SIZE	40960
#define		MENU_ITEMS	6
#define		SPEED_ITEMS	3
#define		TEST_ITEMS	2

/*
	j^f[^i[obt@
*/
static char		line_buf[BUF_SIZE];
static unsigned	byte_count = 0, err_count = 0;
static char		*line_p, *line_max;

/*
	zʃobt@
*/
static int		vmap[16][28];

static BOOL		fchecked = FALSE;
static BOOL		ftest = FALSE;
static BOOL		fhex = TRUE;
static unsigned	view_top, view_bottom, view_temp;

static int		menu_top = 0;
static int		menu_cur_pos = 0;
static int		menu_view_pos = 0;

static char		font_buf[8];

/*
	VAM荞ݏ
*/
void far rx_interrupt(void)
{
	int		rc;

	switch((rc = comm_receive_char()))
	{
		case ERR_SIO_TIMEOUT:
			break;
		case ERR_SIO_CANCEL:
		case ERR_SIO_OVERRUN:
			err_count++;
			break;
		default:
			if(byte_count < BUF_SIZE)
			{
				*(line_p++) = (char)rc;
				byte_count++;
			}
	}
}

/*
	VAM荞ݏ(eXg[h)
*/
void far rx_interrupt_test(void)
{
	int		rc;

	switch((rc = comm_receive_char()))
	{
		case ERR_SIO_TIMEOUT:
			break;
		case ERR_SIO_CANCEL:
		case ERR_SIO_OVERRUN:
			err_count++;
			break;
		default:
			if(byte_count < BUF_SIZE)
			{
				*(line_p++) = (char)((rc >> 4) | 0xA0);
				*(line_p++) = (char)((rc & 0x0F) | 0xB0);
				byte_count += 2;
			}
	}
}

/*
	VAwoCgM
*/
int comm_recv(char far* recv_p, int len)
{
	int		rc, rlen = 0;

	while(rlen < len)
	{
		switch((rc = comm_receive_char()))
		{
			case ERR_SIO_CANCEL:
			case ERR_SIO_TIMEOUT:
			case ERR_SIO_OVERRUN:
				return rc;
		}

		*(recv_p++) = (char)rc;
		rlen++;
	}

	return rlen;
}

/*
	CXe[^XLEDON/OFF
*/
void set_led(int no, int stat)
{
	screen_set_char(SCREEN2, 12 + (no * 2), 1, 2, 1, led + (stat ? 2 : 0));
}

/*
	ʏ
*/
void init(void)
{
	display_control(DCM_SCR1|DCM_SCR2|DCM_SPR);
	lcd_set_color(0x6420, 0xFCA8);
	palette_set_color( 0, 0x7520);
	text_screen_init();
}

/*
	Os\
*/
int view_line(unsigned log_count, int row)
{
	char		c1, c2;
	int			i, dir, len = 0;
	unsigned	code;
	char far	*log_p;

	log_p = line_buf + log_count;

	for(i = 0; i < 9; i++)
	{
		c1 = *(log_p++);
		c2 = *(log_p++);
		if(i == 0)
		{
			dir = ((c1 & 0xF0) == 0xA0) ? 0 : 1;
			vmap[row][0] = ab[dir * 2];				/* A->B / A<-B */
			vmap[row][1] = ab[dir * 2 + 1];
		}
		else
		{
			if(dir != (((c1 & 0xF0) == 0xA0) ? 0 : 1)) break;
			vmap[row][i * 3 + 1] = dir;				/*  */
		}
		if(fhex)
		{
			vmap[row][i * 3 + 2] = digit[(c1 & 0x0F) + dir * 16];
			vmap[row][i * 3 + 3] = digit[(c2 & 0x0F) + dir * 16];
		}
		else
		{
			vmap[row][i * 3 + 2] = dir;
			code = ((c1 & 0x0F) << 4) | (c2 & 0x0F);
			if((code >= 0x20)&&(code <= 0x7F))
				vmap[row][i * 3 + 3] = ascii[code - 0x20 + dir * 96];
			else
				vmap[row][i * 3 + 3] = P_GAP + dir;
		}

		len += 2;
		log_count += 2;
		if(log_count >= byte_count) break;
	}
	return len;
}

/*
	Oʕ\
*/
void view_screen(unsigned start)
{
	int			i;
	unsigned	lc;

	/*
		zVRAM
	*/
	memset(vmap, 0, sizeof(vmap));

	view_top = lc = start;
	for(i = 0; i < 16; i++)
	{
		view_bottom = lc;
		lc += view_line(lc, i);
		if(lc >= byte_count) break;
	}

	screen_set_char(SCREEN2, 0, 2, 28, 16, vmap);
	text_put_numeric(0, 1, 5, NUM_ALIGN_RIGHT, (start >> 1) + 1);
}

/*
	O̍s
*/
int skip_prev(unsigned *log_pos)
{
	int			i, dir1, dir2, len, mod;
	unsigned	pos;

	pos = *log_pos;
	if(pos == 0) return -1;						/* f[^̐擪 */
	if(pos == 2)
	{
		*log_pos = 0;
	 	return 0;								/* f[^̐擪 */
	}
	line_p = line_buf + pos;
	dir1 = ((*line_p & 0xF0) == 0xA0) ? 0 : 1;	/* ݂̕ */
	line_p -= 2;
	dir2 = ((*line_p & 0xF0) == 0xA0) ? 0 : 1;	/* O̕ */
	if(dir1 != dir2)
	{
		/*
			Õf[^Ⴄ̃f[^ubN
		*/
		while(line_p != line_buf)		/* ubN̐擪܂ők */
		{
			line_p -= 2;
			if(dir2 != (((*line_p & 0xF0) == 0xA0) ? 0 : 1))
			{
				line_p += 2;
				break;
			}
		}
		len = (pos - (line_p - line_buf));		/* ubN */
		if((mod = len % 18) != 0)
			*log_pos = pos - mod;				/* s18oCgŊ] */
		else
			*log_pos = pos - 18;				/* ؂鎞͈s߂ */
	}
	else
	{
		/*
			Õf[^̃f[^ubN
		*/
		for(i = 0; i < 8; i++)
		{
			if(dir1 != (((*line_p & 0xF0) == 0xA0) ? 0 : 1))
			{
				line_p += 2;
				break;
			}
			if(line_p == line_buf) break;		/* f[^̐擪 */
			line_p -= 2;
		}
		*log_pos = line_p - line_buf;
	}
	return 0;
}

/*
	̍s
*/
int skip_next(unsigned *log_pos)
{
	int		i, dir;

	line_p = line_buf + (*log_pos);
	dir = ((*line_p & 0xF0) == 0xA0) ? 0 : 1;
	line_p += 2;
	if(line_p >= line_max) return -1;			/* f[^̍Ō */
	for(i = 0; i < 8; i++)
	{
		if(dir != (((*line_p & 0xF0) == 0xA0) ? 0 : 1)) break;
		line_p += 2;
		if(line_p >= line_max) return -1;		/* f[^̍Ō */
	}
	*log_pos = line_p - line_buf;
	return 0;
}

/*
	Ō̍s
*/
int skip_last(unsigned *log_pos)
{
	int			dir, mod;
	unsigned	pos, len;

	pos = *log_pos;
	if(!ftest)
	{
		if(pos == 0) return -1;						/* f[^̐擪 */
		if(pos == 2)
		{
			*log_pos = 0;
		 	return 0;								/* f[^̐擪 */
		}
		line_p = line_buf + pos;
		dir = ((*line_p & 0xF0) == 0xA0) ? 0 : 1;	/* ݂̕ */
		while(line_p != line_buf)		/* ubN̐擪܂ők */
		{
			line_p -= 2;
			if(dir != (((*line_p & 0xF0) == 0xA0) ? 0 : 1))
			{
				line_p += 2;
				break;
			}
		}
		len = (pos - (line_p - line_buf));		/* ubN */
	}
	else
	{
		len = pos;
	}
	if((mod = len % 18) != 0)
		*log_pos = pos - mod;				/* s18oCgŊ] */
	else
		*log_pos = pos - 18;				/* ؂鎞͈s߂ */
	return 0;
}

/*
	OsXN[Abv
*/
void view_rollup(int lc)
{
	int		i;

	for(i = 0; i < lc; i++)
	{
		if(skip_next(&view_bottom) == -1)				/* ̍s̐擪 */
		{
			break;
		}

		/*
			zVRAMXN[
		*/
		memcpy(vmap, vmap[1], sizeof(vmap) - 56);

		/*
			ŉs\
		*/
		memset(vmap[15], 0, 56);
		view_line(view_bottom, 15);

		/*
			\
		*/
		screen_set_char(SCREEN2, 0, 2, 28, 16, vmap);

		/*
			\ʒu|C^XV
		*/
		skip_next(&view_top);
	}
}

/*
	OsXN[_E
*/
void view_rolldown(int lc)
{
	int		i;

	for(i = 0; i < lc; i++)
	{
		if(skip_prev(&view_top) == -1)				/* O̍s̐擪 */
		{
			break;
		}

		/*
			zVRAMXN[i蔲Ax悤ȂAZuŏj
		*/
		memcpy(vmap[15], vmap[14], 56);
		memcpy(vmap[14], vmap[13], 56);
		memcpy(vmap[13], vmap[12], 56);
		memcpy(vmap[12], vmap[11], 56);
		memcpy(vmap[11], vmap[10], 56);
		memcpy(vmap[10], vmap[9], 56);
		memcpy(vmap[9], vmap[8], 56);
		memcpy(vmap[8], vmap[7], 56);
		memcpy(vmap[7], vmap[6], 56);
		memcpy(vmap[6], vmap[5], 56);
		memcpy(vmap[5], vmap[4], 56);
		memcpy(vmap[4], vmap[3], 56);
		memcpy(vmap[3], vmap[2], 56);
		memcpy(vmap[2], vmap[1], 56);
		memcpy(vmap[1], vmap[0], 56);

		/*
			ŏs\
		*/
		memset(vmap, 0, 56);
		view_line(view_top, 0);

		/*
			\
		*/
		screen_set_char(SCREEN2, 0, 2, 28, 16, vmap);

		/*
			\ʒu|C^XV
		*/
		skip_prev(&view_bottom);
	}
}

/*
	O`FbN
*/
BOOL log_check(void)
{
	int		i, rc;

	line_p = line_buf;
	for(i = 0; i < byte_count; i++)
	{
		rc = *(line_p++);
		switch(rc & 0xF0)
		{
			case 0x80:
				if(i % 2)
				{
					return FALSE;		/* oCgڂłȂ΃G[ */
				}
				break;
			case 0x90:
				if(!(i % 2)) {
					return FALSE;		/* oCgڂłȂ΃G[ */
				}
				break;
			case 0xA0:
				if(i % 2) {
					return FALSE;		/* oCgڂłȂ΃G[ */
				}
				break;
			case 0xB0:
				if(!(i % 2))
				{
					return FALSE;		/* oCgڂłȂ΃G[ */
				}
				break;
			case 0xF0:
				i = byte_count;
				break;
			default:
				return FALSE;
		}
	}

	return TRUE;
}

/*
	O\C
*/
void view_main(void)
{
	int		i, key;

	if(byte_count == 0)
	{
		text_put_string(0, 0, "Of[^@@@");
		text_put_string(0, 1, "܂@@@@");
		key_wait();
		return;
	}

	/*
		`FbNς݂łȂ΃Of[^`FbN
	*/
	if(!fchecked)
	{
		font_set_color(0x0c);	/* ] */
		text_put_string(0, 0, "O`FbN||");
		font_set_color(0x03);	/* ʏ */
		text_put_string(0, 1, "@@@@@@@@@@@");

		if(!log_check())
		{
			font_set_color(0x0c);	/* ] */
			text_put_string(0, 0, "Mf[^G[@");
			key_wait();
			return;
		}
		fchecked = TRUE;
	}

	/*
		\Jn
	*/
	font_set_color(0x0c);	/* ] */
	text_put_string(0, 0, "j^O\|");
	font_set_color(0x03);	/* ʏ */
	text_put_string(0, 1, "@@@@@[B]:I");

	/*
		ʕ\
	*/
	view_screen(0);

	while(TRUE)
	{
		key = key_wait();
		if((key & KEY_B)||(key & KEY_START))
		{
			break;
		}
		else if(key & KEY_A)
		{
			/*
				\؊
			*/
			fhex = !fhex;
			view_screen(view_top);
		}
		else if(key & KEY_DOWN1)
		{
			/*
				PsXN[Abv
			*/
			view_rollup(1);
		}
		else if(key & KEY_UP1)
		{
			/*
				PsXN[_E
			*/
			view_rolldown(1);
		}
		else if(key & KEY_DOWN2)
		{
			/*
				POsXN[Abv
			*/
			view_rollup(10);
		}
		else if(key & KEY_UP2)
		{
			/*
				POsXN[_E
			*/
			view_rolldown(10);
		}
		else if(key & KEY_LEFT2)
		{
			/*
				O̐擪
			*/
			view_screen(0);
		}
		else if(key & KEY_RIGHT2)
		{
			/*
				O̍Ō
			*/
			view_temp = byte_count - 2;
			skip_last(&view_temp);
			for(i = 0; i< 15; i++)
			{
				if(skip_prev(&view_temp) == -1) break;
			}
			view_screen(view_temp);
		}

		text_put_numeric(0, 1, 5, NUM_ALIGN_RIGHT, (view_top >> 1) + 1);
	}
}

/*
	j^Jn
*/
void mon_start()
{
	static intvector_t 	iv;
	char		rbuf[10];
	int			result;
	int			key;

	/*
		
	*/
	lcd_set_segments(0);
	byte_count = err_count = 0;
	line_p = line_buf;
	fchecked = FALSE;

	/*
		荞݃tbNݒ
	*/
	if(!ftest)
		iv.callback = (void (near *)())FP_OFF(rx_interrupt);
	else
		iv.callback = (void (near *)())FP_OFF(rx_interrupt_test);
	iv.cs =  _asm_inline("mov ax, cs");
	iv.ds =  _asm_inline("mov ax, ds");
	sys_interrupt_set_hook(SYS_INT_RECEIVEREADY, &iv, NULL);

	/*
		j^JnR}h
	*/
	if(!ftest)
	{
 		comm_send_char('\x47');			/* 'G' */
	}

	while(byte_count < BUF_SIZE)
	{
		key = key_hit_check();
		if(key & KEY_B)
		{
			break;
		}
		lcd_set_segments(byte_count & (LCDSEG_AUX3|LCDSEG_AUX2|LCDSEG_AUX1));
	}

	/*
		荞݃tbN
	*/
	sys_interrupt_reset_hook(SYS_INT_RECEIVEREADY, NULL);

	/*
		j^IR}h
	*/
	if(!ftest)
	{
	 	comm_send_char('\x45');			/* 'E' */
		result = comm_recv(rbuf, 1);
	}

	/*
		I
	*/
	font_set_color(0x0c);	/* ] */
	text_put_string(0, 0, "I@@@@");
	font_set_color(0x03);	/* ʏ */
	text_put_string(0, 1, "@@@@@@@@@@@");
	comm_close();
	comm_open();

	/*
		LCDZOgNA
	*/
	lcd_set_segments(0);

	/*
		obt@t
	*/
	if(byte_count == BUF_SIZE)
	{
		font_set_color(0x0c);	/* ] */
		text_put_string(0, 0, "Mobt@t@");
		font_set_color(0x03);	/* ʏ */
		text_put_string(0, 1, "@@@@@@@@@@@");
		key_wait();
	}

	/*
		j^
	*/
	text_put_string(0, 0, "@@@@@bM@");
	text_put_string(0, 1, "@@@@@bG[");
	text_put_numeric(1, 0, 5, 0, byte_count >> 1);
	text_put_numeric(1, 1, 5, 0, err_count);
	key_wait();

	line_max = line_buf + byte_count;		/* Mobt@̍Ō+1̔Ԓn */
}

/*
	j^
*/
void mon_line()
{
	char	rbuf[30];
	int		result;

	font_set_color(0x0c);	/* ] */
	text_put_string(0, 0, "j^Jn܂");
	font_set_color(0x03);	/* ʏ */
	text_put_string(0, 1, "@@@@@[A]:OK");
	if(key_wait() != KEY_A) return;

	font_set_color(0x0c);	/* ] */
	text_put_string(0, 0, "j^|||||");
	font_set_color(0x03);	/* ʏ */
	text_put_string(0, 1, "@@@@@[B]:f");

	/*
		ڑ`FbN
	*/
	if(!ftest)
	{
	 	comm_send_char('\x56');			/* 'V' */
		result = comm_recv(rbuf, 22);

		switch(result)
		{
			case ERR_SIO_CANCEL:
			case ERR_SIO_TIMEOUT:
			case ERR_SIO_OVERRUN:
				text_put_string(0, 0, "Cj^@@");
				text_put_string(0, 1, "ڑĂ܂");
				key_wait();
				return;
		}
	}
	/*
		j^Jn
	*/
	mon_start();
}

/*
	CԎ擾
*/
void get_status()
{
	char		rbuf[10], sc, mask;
	int			i, result;

	if(ftest) return;

	font_set_color(0x0c);	/* ] */
	text_put_string(0, 0, "CԎ擾|");
	font_set_color(0x03);	/* ʏ */
	text_put_string(0, 1, "@@@@@@@@@@@");

	/*
		CԂ擾
	*/
 	comm_send_char('\x53');			/* 'S' */
	result = comm_recv(rbuf, 2);

	switch(result)
	{
		case ERR_SIO_CANCEL:
		case ERR_SIO_TIMEOUT:
		case ERR_SIO_OVERRUN:
			text_put_string(0, 0, "Cj^@@");
			text_put_string(0, 1, "ڑĂ܂");
			key_wait();
			break;
		default:
			sc = rbuf[0];	/* LON */
			for(i = 0, mask = 0x01; i < 8; i++, mask <<= 1)
			{
				set_led(i, !(sc & mask));
			}
	}
}

/*
	j^xݒ
*/
int speed_menu(void)
{
	static char	*speed_menu[] = { "@@4800bps@@",
								  "@@9600bps@@",
								  "@19200bps@@"
						};
	static char	*speed_test[] = { "@@9600bps@@",
								  "@38400bps@@"
						};
	static int	speed_top = 0;
	static int	speed_cur_pos = 1;
	static int	speed_view_pos = 1;

	int		i, key, items;
	BOOL	fChange = TRUE;
	char	**menu_p;

	items = (ftest) ? TEST_ITEMS : SPEED_ITEMS;
	menu_p = (ftest) ? speed_test : speed_menu;

	while(TRUE)
	{
		if(fChange)
		{
			for(i = 0; i < 2; i++)
			{
				if(speed_cur_pos == (speed_top + i))
				{
					font_set_color(0x0c);	/* ] */
					text_put_string(0, i, menu_p[speed_top + i]);
					font_set_color(0x03);	/* ʏ */
				}
				else
				{
					text_put_string(0, i, menu_p[speed_top + i]);
				}
			}
			fChange = FALSE;
		}

		if((key = key_wait()) != 0)
		{
			if((key == KEY_UP1)&&(speed_cur_pos > 0))
			{
				speed_cur_pos--;
				if(speed_view_pos == 1)
				{
					speed_view_pos = 0;
				}
				else
				{
					speed_top--;
				}
				fChange = TRUE;
			}
			else if((key == KEY_DOWN1)&&(speed_cur_pos < items - 1))
			{
				speed_cur_pos++;
				if(speed_view_pos == 0)
				{
					speed_view_pos = 1;
				}
				else
				{
					speed_top++;
				}
				fChange = TRUE;
			}
			else if(key == KEY_A)
			{
				return speed_cur_pos;
			}
			else if(key == KEY_START)
			{
				return -1;
			}
		}
	}
}

/*
	Oۑ
*/
void save_log()
{
	static char filename[30];
	unsigned	i;
	FILE far 	*fp;

	if(byte_count == 0)
	{
		text_put_string(0, 0, "Of[^@@@");
		text_put_string(0, 1, "܂@@@@");
		key_wait();
		return;
	}

	font_set_color(0x0c);	/* ] */
	text_put_string(0, 0, "Oۑ܂@");
	font_set_color(0x03);	/* ʏ */
	text_put_string(0, 1, "@@@@@[A]:OK");
	if(key_wait() != KEY_A) return;

	font_set_color(0x0c);	/* ] */
	text_put_string(0, 0, "Oۑ||||");
	font_set_color(0x03);	/* ʏ */
	text_put_string(0, 1, "@@@@@@@@@@@");

	strcpy(filename, "/ram0/rsmon.dat");
	unlink(filename);
	if(creat(filename, 6, (byte_count + 127) / 128) != E_FS_SUCCESS)
	{
		text_put_string(0, 0, "t@C쐬Ł@@");
		text_put_string(0, 1, "G[@@@");
		key_wait();
	 	return;
	}
	fs_setinfo(filename, "Cj^O");
	if(!(fp = fopen(filename, "w")))
	{
		text_put_string(0, 0, "t@CI[vŁ");
		text_put_string(0, 1, "G[@@@");
		key_wait();
	 	return;
	}
	line_p = line_buf;
	for(i = 0; i < ((byte_count + 127) / 128) * 128; i++)
	{
		if(i < byte_count)
		{
			if(fputc(*(line_p++), fp) == EOF)
			{
				text_put_string(0, 0, "t@CŁ@@");
				text_put_string(0, 1, "G[@@@");
				key_wait();
			 	return;
			}
		}
		else
		{
			fputc(0, fp);
		}
		lcd_set_segments(i & (LCDSEG_AUX3|LCDSEG_AUX2|LCDSEG_AUX1));
	}
	fclose(fp);
	lcd_set_segments(0);

	return;
}

/*
	j^j[I
*/
int mon_menu(void)
{
	static char	*menu[] = { "@@j^xݒ@@",
							"@@@j^Jn@@@",
							"@@CԎ擾@@",
							"@@j^O\@@",
							"@@@@ہ@@@@@",
							"@@@@I@@@@@"
						};

	int		i, key;
	BOOL	fChange = TRUE;

	while(TRUE)
	{
		if(fChange)
		{
			for(i = 0; i < 2; i++)
			{
				if(menu_cur_pos == (menu_top + i))
				{
					font_set_color(0x0c);	/* ] */
					text_put_string(0, i, menu[menu_top + i]);
					font_set_color(0x03);	/* ʏ */
				}
				else
				{
					text_put_string(0, i, menu[menu_top + i]);
				}
			}
			fChange = FALSE;
		}

		if((key = key_wait()) != 0)
		{
			if((key == KEY_UP1)&&(menu_cur_pos > 0))
			{
				menu_cur_pos--;
				if(menu_view_pos == 1)
				{
					menu_view_pos = 0;
				}
				else
				{
					menu_top--;
				}
				fChange = TRUE;
			}
			else if((key == KEY_DOWN1)&&(menu_cur_pos < MENU_ITEMS - 1))
			{
				menu_cur_pos++;
				if(menu_view_pos == 0)
				{
					menu_view_pos = 1;
				}
				else
				{
					menu_top++;
				}
				fChange = TRUE;
			}
			else if(key == KEY_A)
			{
				return menu_cur_pos;
			}
			else if(key == KEY_START)
			{
				return -1;
			}
		}
	}
}

/*
	j^C
*/
void mon_main(void)
{
	int			i, result;
	char		rbuf[10];
	BOOL		fQuit = FALSE;

	display_control(0);

	/*
		LN^p^[ݒ
	*/
	font_set_monodata( 0, 40, bmp_pat);				/* ʏ */
	font_set_color(0x0c);
	font_set_monodata(40, 18, bmp_pat + 40 * 8);	/* ] */
	font_set_color(0x03);
	font_set_monodata(58,  2, bmp_pat + 58 * 8);

	for(i = 0; i < 96; i++)
	{
		text_get_fontdata(i + 0x20, font_buf);
		font_set_monodata(P_ASCII + i, 1, font_buf);
		font_set_color(0x0c);
		font_set_monodata(P_ASCII + 96 + i, 1, font_buf);
		font_set_color(0x03);
	}

	/*
		j^ʏ
	*/
	display_control(DCM_SCR1|DCM_SCR2|DCM_SPR);
	screen_fill_char(SCREEN2, 0, 0, 28, 18, 0);
	text_window_init(0, 0, 12, 2, 256);

	/*
		CXe[^X
	*/
	for(i = 0; i < 8; i++)
	{
		screen_set_char(SCREEN2, 12 + (i * 2), 0, 2, 1, line + (i * 2));
		set_led(i, 0);
	}

	/*
		͑҂
	*/
	while(!fQuit)
	{
		switch(mon_menu())
		{
			case -1:
			case 5:
				fQuit = TRUE;
				break;
			case 0:
				result = speed_menu();	/* j^x */
				if(result >= 0)
				{
					/*
						j^xݒ
					*/
					if(!ftest)
					{
					 	comm_send_char('\x30' + result);	/* '0'`'2' */
						result = comm_recv(rbuf, 1);

						switch(result)
						{
							case ERR_SIO_CANCEL:
							case ERR_SIO_TIMEOUT:
							case ERR_SIO_OVERRUN:
								text_put_string(0, 0, "Cj^@@");
								text_put_string(0, 1, "ڑĂ܂");
								key_wait();
						}
					}
					else
					{
						comm_close();
					    comm_set_baudrate(COMM_SPEED_9600 + result);
					    comm_open();
					}
				}
				break;
			case 1:
				mon_line();				/* j^Jn */
				menu_top = 3;			/* j[ʒuO\ɐݒ */
				menu_cur_pos = 3;
				menu_view_pos = 0;
				break;
			case 2:
				get_status();			/* CԎ擾 */
				break;
			case 3:
				view_main();			/* O\ */
				break;
			case 4:
				save_log();				/* Oۑ */
				break;
		}
	}
}

/*
	C
*/
void main(void)
{
	int		result;
	char	rbuf[30];

	/*
		
	*/
	init();

	/*
		COM|[gJ
	*/
    comm_set_baudrate(COMM_SPEED_38400);
    comm_open();
	comm_set_timeout(10, 1);
	text_put_string(9,  7, "");
	text_put_string(9,  8, "ڑ`FbN");
	text_put_string(9,  9, "");

	/*
		o[W擾
	*/
 	comm_send_char('\x56');			/* 'V' */
	result = comm_recv(rbuf, 22);

	switch(result)
	{
		case ERR_SIO_CANCEL:
		case ERR_SIO_TIMEOUT:
		case ERR_SIO_OVERRUN:
			text_put_string(5,  7, "");
			text_put_string(5,  8, "Cj^ڑĂ܂");
			text_put_string(5,  9, "");
			key_wait();
			text_put_string(5,  7, "@@@@");
			text_put_string(5,  8, "@@eXg[hŋN܂@@");
			text_put_string(5,  9, "@@@@");
			key_wait();
			ftest = TRUE;
	}

	/*
		j^x̃ftHgݒ
	*/
	if(!ftest)
	{
	 	comm_send_char('\x31');			/* 9600bps */
		result = comm_recv(rbuf, 1);
	}

	/*
		j^C
	*/
	mon_main();				/* j^̃C */

	/*
		COM|[g
	*/
	comm_close();
}
